#include <stdint.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "dcf77.h"
#include "clock.h"
#include "uartdrv.h"
#include "stepper.h"
#include "validLed.h"


int main() {

  // esd prot
  DDRD |= (1 << PD5) | (1 << PD6);


  uartdrvInit();
  clockInit();
  dcf77Init();
  stepperInit();
  validLedInit();



  sei();

  printf("MyClock started\n");



  while (1) {
    dcf77Engine();

    stepperEngine();

    validLedEngine();


    if (clockNextSecond()) {
      clock_t clock = clockGetClock();
      printf("Time: %02d:%02d:%02d %d %02d.%02d.%02d\n",
          clock.year, clock.month, clock.day, clock.weekday,
          clock.hour, clock.minute, clock.second);
    }

    if (clockNextMinute()) {
      opTime_t opTime = clockGetOpTime();
      printf("**** OpTime: %d %02d:%02d:%02d\n", opTime.day, opTime.hour, opTime.minute, opTime.second);
    }

  }

}

